
-- Function to apply vertical flip flag to an object if the player has it
rawset(_G, "DoVerticalFlip", function(pmo, object)
    if pmo.eflags & MFE_VERTICALFLIP then
        object.eflags = $1|MFE_VERTICALFLIP
	else
		object.eflags = $ & ~MFE_VERTICALFLIP
    end
end)
rawset(_G, "apply_vertical_flip", DoVerticalFlip)
local function RemoveSMoke(p)
	p.mo.color = p.pastcolor
	p.mo.rollangle = 0
	if p.wascolor == false
		p.mo.colorized = false
	end
	p.sheld = false
end


addHook("ShieldSpecial", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.powers[pw_shield] == SH_ARMAGEDDON
		p.sheld = true
		P_StartQuake(20*FU, 4)
		P_Thrust(p.mo,p.mo.angle, 34*FU)
		P_SetObjectMomZ(p.mo, 40*FU)
		p.pastcolor = p.mo.color
		p.mo.state = S_PLAY_DRWN
		p.mo.color = SKINCOLOR_BLACK
		S_StartSound(p.mo, sfx_ugow)
		if not p.mo.colorized then--i mean you could have that command that colorizes you
			p.mo.colorized = true
			p.wascolor = false
			else
			p.wascolor = true
		end
	end 
end)



addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.sheld == true
		p.mo.rollangle = $ + FixedAngle(4*FU)
		if leveltime%P_RandomRange(1,5) == 0
			local r = P_RandomRange(-30,30)*FU
			local smog = P_SpawnMobj(p.mo.x+r, p.mo.y+r, p.mo.z+r, MT_SMOKE)
			apply_vertical_flip(p.mo, smog)
			smog.scale = p.mo.scale
			smog.spritexscale = 2*FU
			smog.spriteyscale = 2*FU
		end
	end
end)
			
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and P_IsObjectOnGround(p.mo)
		and p.sheld == true 
		RemoveSMoke(p)
	end
end)
		

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.sheld == true
		if p.mo.state ~= S_PLAY_DRWN
			RemoveSMoke(p)
		end
	end
end)
			
		